#include <EEPROM.h>

// this constant won't change:
const int  buttonPin = 12;    // the pin that the pushbutton is attached to


// Variables will change:
unsigned int buttonPushCounter; // = 0;   // counter for the number of button presses
unsigned int buttonState = 0;         // current state of the button
unsigned int lastButtonState = 0;     // previous state of the button

void SaveToEEPROM(int address ,byte value){
  EEPROM.write(address, value); 
}

byte ReadFromEEPROM(int address){
  return EEPROM.read(address);    
}

void setup() {
  // initialize the button pin as a input:
  pinMode(buttonPin, INPUT);

  // initialize serial communication:
  Serial.begin(9600);
  
  //Restore last saved buttonPushCounter value 
  buttonPushCounter = ReadFromEEPROM(0);
}


void loop() {
  // read the pushbutton input pin:
  buttonState = digitalRead(buttonPin);

  // compare the buttonState to its previous state
  if (buttonState != lastButtonState) {
    // if the state has changed, increment the counter
    if (buttonState == HIGH) {
      // if the current state is HIGH then the button
      // wend from off to on:
      buttonPushCounter++;
      Serial.println("on");
      Serial.print("number of button pushes:  ");
      Serial.println(buttonPushCounter, DEC);
      
      //Save the new buttonPushCounter into EEPROM
      SaveToEEPROM(0,buttonPushCounter);
      
    }
    else {
      // if the current state is LOW then the button
      // went from on to off:
      Serial.println("off");
    }
  }
  // save the current state as the last state,
  //for next time through the loop
  lastButtonState = buttonState;

 
 
}
